'use strict';
var express = require('express'),
	router = express.Router(),
	returnCode = require('../../utils/returnCode'),
	_ = require('lodash');

var mongoose = require('mongoose');
var forumUserService=require('../../service/forumUserService');
var forumThreadService=require('../../service/forumThreadService');
var httpService=require('../../service/httpService');

var async=require('async');

var user=require('../../utils/user');

module.exports = function(app) {
	app.use('/admin/forum', router);
};

//验证用户身份
router.post('/user/identifyUser',function(req,res,next){
	var entity=req.body;
	req.session.mobileForumUser=null;
	if(!req.session.mobileForumUser){
			forumUserService.getUserByUid(entity.uid,function(err,doc){
				if(err){
					console.log(err);
					res.json('error');
				}else{
					if(doc){
						req.session.mobileForumUser={
							userId:doc._id,
							openId:doc.uid
						};
						res.json('success');
					}else{
						forumUserService.createUser(entity,function(err,doc){
							if(err){
								console.log(err);
								res.json('error');
							}else{
								req.session.mobileForumUser={
									userId:doc._id,
									openId:doc.uid
								};
								res.json('success');
							}
						});
					}
				}
			});
		}else{
			res.json('success');
		}
});
//微信分享带来用户
router.get('/user/from/share', function(req, res, next) {
    var mid = req.query.mid,
        action = req.query.action,
        ent_code = req.query.ent_code;
    httpService.sendRequest(ent_code,mid,action);
    res.status(200).end();
});