'use strict';
var express = require('express'),
	router = express.Router(),
	returnCode = require('../../utils/returnCode'),
	_ = require('lodash'),
	then = require('thenjs'),
	moment = require('moment'),
	mongoose = require('mongoose');
//模型
var ForumPvLog = mongoose.model('ForumPVLog'),
	ForumUvLog = mongoose.model('ForumUVLog'),
	ForumThread = mongoose.model('ForumThread');

module.exports = function(app) {
	app.use('/admin/forum', router);
};

//社区情况(首页)
router.get('/statistic',function(req, res, next) {
	var yesterday = moment(new Date().getTime() - 24*3600*1000).format('YYYY-MM-DD'),
		before_yesterday = moment(new Date().getTime() - 2*24*3600*1000).format('YYYY-MM-DD');
	var y_begin = 	yesterday,
		y_end = yesterday+' 23:59:59',
		by_begin = before_yesterday,
		by_end = before_yesterday+' 23:59:59';
	var q = {ent_code:req.session.user.ent_code};
	then.parallel([
		function(cont){
			//昨天访问用户
			q.created = {$gte:y_begin,$lte:y_end};
			ForumUvLog.count(q,cont);
		},function(cont){
			//前天访问用户
			q.created = {$gte:by_begin,$lte:by_end};
			ForumUvLog.count(q,cont);
		},
		function(cont){
			//昨天发帖数
			q.created = {$gte:y_begin,$lte:y_end};
			ForumThread.count(q,cont);
		},
		function(cont){
			//前天发帖数
			q.created = {$gte:by_begin,$lte:by_end};
			ForumThread.count(q,cont);
		}
	]).then(function(cont,datas){
		var y_user = datas[0],
			by_user = datas[1],
			y_thread = datas[2],
			by_thread = datas[3];
		var user_rate = (by_user === 0)?y_user:(y_user/by_user).toFixed(4)-1,
			thread_rate = (by_thread === 0)?y_thread:(y_thread/by_thread).toFixed(4)-1;
		cont(null,y_user,user_rate,y_thread,thread_rate);	
	}).then(function(cont,y_user,user_rate,y_thread,thread_rate){
		res.json({result:true,data:{
			user:y_user,
			user_rate:Math.round(user_rate>1?100:user_rate<0?0:user_rate*100),
			thread:y_thread,
			thread_rate:Math.round(thread_rate>1?100:thread_rate<0?0:thread_rate*100)
		}})
	}).fail(function(cont,err){
		console.error(err);
		res.json({result:false,err:err});
	});
});	

